'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDomPolyfill = require('react-dom-polyfill');

var _reactDomPolyfill2 = _interopRequireDefault(_reactDomPolyfill);

var _loadModules = require('./load-modules');

var _Loader = require('./components/Loader');

var _Loader2 = _interopRequireDefault(_Loader);

var _PropsProxy = require('./components/proxies/PropsProxy');

var _PropsProxy2 = _interopRequireDefault(_PropsProxy);

var _StateProxy = require('./components/proxies/StateProxy');

var _StateProxy2 = _interopRequireDefault(_StateProxy);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var ReactDOM = (0, _reactDomPolyfill2.default)(_react2.default);

var createDomContainer = function createDomContainer() {
  var node = document.createElement('div');
  node.style.position = 'absolute';
  node.style.width = '100%';
  node.style.height = '100%';

  return node;
};

module.exports = function (_ref) {
  var proxies = _ref.proxies,
      components = _ref.components,
      fixtures = _ref.fixtures,
      containerQuerySelector = _ref.containerQuerySelector;

  var container = containerQuerySelector ? document.querySelector(containerQuerySelector) : document.body.appendChild(createDomContainer());

  ReactDOM.render(_react2.default.createElement(_Loader2.default, {
    components: (0, _loadModules.loadComponents)(components),
    fixtures: (0, _loadModules.loadFixtures)(fixtures),
    proxies: [].concat(_toConsumableArray(proxies), [
    // Loaded by default in all configs
    (0, _StateProxy2.default)(),
    // The final proxy in the chain simply renders the selected component
    _PropsProxy2.default])
  }), container);
};